#**************************************************************
#Set up CMISS mechanics model
#
#
fem def para;r;memory        

fem de coord;r;allow_mapping

$name = "demo2";

fem define bas;r;TriCubicHerm
fem def;add base;r;BiCubicHerm
fem def;add base;r;TriLinearPress
fem def;add base;r;BiLinear

fem define node;r;$name
fem define elem;r;$name

fem def fibre;d
fem def elem;d          fibre

# fem def data;r;dummy
# fem update field from geometry
# fem define elem;d field
# 
# fem def xi;c
# fem def fit;r;dummy geometry
# fem def mapping;r;$name

#set diag on
for $j (1..3){
   # This option will make all the lines straight, but I have
   # turned it off because it is not in the main cm source and
   # I want to be sure that it isn't causing any issues.
   #fem update nodes deriv $j versions individual
   fem update nodes deriv $j
}
#set diag off

#fem update scale_factor normalise

#
# Export initial mesh
# 
$ref = "initial";

fem export nodes;$ref as $ref;
fem export elements;$ref as $ref;

fem define node;w;$name."_exp"
fem define elem;w;$name."_exp"

#
# Refine doesn't work because the mappings are not updated.
#
#fem refine xi 1
#fem refine xi 2
#fem refine xi 3

fem def equa;r;mechanics          lock
fem def mat;r;mooney_rivlin

# fem group node 1,2,3,4 as BOTTOMNODES
# fem group node 9,10,11,12 as TOPNODES
# #fem group node 5,6,7,8 as TOPNODES
# fem group node 1,2,5,6,9,10 as FRONTNODES
# fem group node 3,4,7,8,11,12 as BACKNODES
# fem group node 1,3,5,7,9,11 as LEFTNODES
# fem group node 2,4,6,8,10,12 as RIGHTNODES

fem group element all external s3=0 as BOTTOM;
fem group nodes xi3=0 element BOTTOM as BOTTOMNODES;

fem group element all external s3=1 as TOP;
fem group nodes xi3=1 element TOP as TOPNODES;

fem list nodes groups


fem def init;r;displace_zx_3elements

fem def solve;r;cubeherm

#fem def mapping;r;$name

#die

fem solv inc 0 iter 4 error 1e-4


#In this example we define displacements
#**************************************************************
#
#**************************************************************
# fem solv inc 0.0001 iter 5 error 1e-4
# fem solv inc 0.0009 iter 5 error 1e-4
# fem solv inc 0.009 iter 5 error 1e-4
# fem solv inc 0.09 iter 5 error 1e-6
# fem solv inc 0.4 iter 5 error 1e-8
# fem solv inc 0.5 iter 30 error 1e-10


$name = "deformed";

fem export nodes;$name as $name field offset 0
fem export elements;$name as $name field offset_elem 0

#view in cmgui if desired
system "cmgui view.com"

